# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey=[]

def install():

    versionsoft = control['version'].split('-',1)[0]
    majeurversion = control['version'].split('.',1)[0]
    softname = 'Adobe Flash Player'

    for uninstall in installed_softwares('Adobe Flash Player'):
        if not 'MsiExec.exe' in uninstall['uninstall_string'] :
            run('"uninstall_flash_player.exe" -uninstall')
        else :
            if not majeurversion in uninstall['name']:
                if Version(uninstall['version']) < Version(versionsoft) :
                    print(u'remove old software' )
                    run(uninstall_cmd(uninstall['key']))

    print("Installing flash for firefox")
    install_msi_if_needed('install_flash_player_%s_plugin.msi' % majeurversion,killbefore=['firefox.exe'],properties={'REMOVE_PREVIOUS':'Yes'})

    print("Installing flash for internet explorer if < win10")
    if windows_version()<Version('6.2.0'):
        install_msi_if_needed('install_flash_player_%s_active_x.msi' % majeurversion,killbefore=['iexplore.exe'],properties={'REMOVE_PREVIOUS':'Yes'})

    print("Installing flash ppapi")
    install_msi_if_needed('install_flash_player_%s_ppapi.msi' % majeurversion,killbefore=['chromium.exe','opera.exe'],properties={'REMOVE_PREVIOUS':'Yes'})

    print("Disable autoupdate")
    if iswin64():
        filecopyto("mms.cfg",makepath(os.environ['SYSTEMROOT'],"SysWOW64","Macromed","Flash"))
    else:
      filecopyto("mms.cfg",makepath(os.environ['SYSTEMROOT'],"System32","Macromed","Flash"))

    print("delete task update")
    listtask = run('schtasks')
    if "Adobe Flash Player Updater" in listtask :
        run('schtasks /Delete /tn "Adobe Flash Player Updater" /f')

    if "Adobe Flash Player PPAPI Notifier" in listtask :
        run('schtasks /Delete /tn "Adobe Flash Player PPAPI Notifier" /f')

    if "Adobe Flash Player NPAPI Notifier" in listtask :
        run('schtasks /Delete /tn "Adobe Flash Player NPAPI Notifier" /f')

    if service_installed('AdobeFlashPlayerUpdateSvc'):
        if service_is_running('AdobeFlashPlayerUpdateSvc'):
            service_stop('AdobeFlashPlayerUpdateSvc')
        run('sc delete AdobeFlashPlayerUpdateSvc')






def update_package():


    proxie = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxie = {'http':proxywapt,'https':proxywapt}

    """Update to current version from macromedia"""

    page = ensure_unicode(wgets('https://get.adobe.com/fr/flashplayer',user_agent='Mozilla/5.0 (Windows NT 6.1; Win64; x64)',proxies=proxie))

    for line in page.splitlines():
        if 'AUTO_ID_columnleft_p_version' in line:
            latest_version = line.split('Version ')[1].split('<')[0]
    print('Latest version: %s' % latest_version)

    major_version = latest_version.split('.',1)[0]

    allmsi = glob.glob('*.msi')
    for msi in allmsi:
        vers = get_msi_properties(msi)['ProductVersion']
        if vers != latest_version :
            remove_file(msi)

    if not isfile('install_flash_player_%s_active_x.msi' % major_version ) :
        wget('https://download.macromedia.com/get/flashplayer/pdc/%s/install_flash_player_%s_active_x.msi' % (latest_version,major_version),os.getcwd(),proxies=proxie)

    if not isfile('install_flash_player_%s_plugin.msi' % major_version ) :
        wget('https://download.macromedia.com/get/flashplayer/pdc/%s/install_flash_player_%s_plugin.msi'  % (latest_version,major_version),os.getcwd(),proxies=proxie)

    if not isfile('install_flash_player_%s_ppapi.msi' % major_version ) :
        wget('https://download.macromedia.com/get/flashplayer/pdc/%s/install_flash_player_%s_ppapi.msi'  % (latest_version,major_version),os.getcwd(),proxies=proxie)

    wget('https://fpdownload.macromedia.com/get/flashplayer/current/support/uninstall_flash_player.exe' ,os.getcwd(),proxies=proxie)

    control.version = get_msi_properties('install_flash_player_%s_active_x.msi' % major_version)['ProductVersion']+'-0'
    control.save_control_to_wapt()
